﻿Partial Public Class Page
    Inherits UserControl
 Dim rc As Rectangle
 Dim bRectInCreation As Boolean
 Dim ptUpperLeftCorner As Point
    Public Sub New()
        InitializeComponent()
    End Sub

 Private Sub LayoutRoot_MouseLeftButtonDown(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseButtonEventArgs)
  If rc IsNot Nothing Then
   LayoutRoot.Children.Remove(rc)
  End If

  Dim p As Point = e.GetPosition(Me)
  bRectInCreation = True
  ptUpperLeftCorner = p
 End Sub

 Private Sub LayoutRoot_MouseMove(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseEventArgs)
  If bRectInCreation Then
   If rc IsNot Nothing Then
    LayoutRoot.Children.Remove(rc)
   End If
   Dim p As Point = e.GetPosition(Me)
   Dim X As Double = Math.Min(p.X, ptUpperLeftCorner.X)
   Dim Y As Double = Math.Min(p.Y, ptUpperLeftCorner.Y)
   Dim W As Double = Math.Abs(p.X - ptUpperLeftCorner.X)
   Dim H As Double = Math.Abs(p.Y - ptUpperLeftCorner.Y)

   rc = New Rectangle()
   rc.SetValue(Canvas.LeftProperty, X)
   rc.SetValue(Canvas.TopProperty, Y)
   rc.Width = W
   rc.Height = H
   rc.Fill = New SolidColorBrush(Color.FromArgb(64, 255, 0, 0))
   LayoutRoot.Children.Add(rc)
  End If
 End Sub

 Private Sub LayoutRoot_MouseLeftButtonUp(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseButtonEventArgs)
  If bRectInCreation Then
   rc.Stroke = New SolidColorBrush(Colors.Red)
   rc.StrokeThickness = 1
   rc.Fill = New SolidColorBrush(Color.FromArgb(0, 0, 0, 0))
  End If
  bRectInCreation = False
 End Sub
End Class